︠4ffb21f5-f456-4fbc-ade4-635970339aa8s︠
%cython
#clib m

cdef extern from "math.h":
    float expf(float x)

def diss_curve(par, amp, float ran=4.0, int res=1200):
    x = [0.0]*res
    y = [0.0]*res
    cdef float step = (ran - 1.0)/res
    cdef int n = len(par)
    cdef int xx
    cdef int i
    cdef int j
    cdef float dif
    cdef float s
    cdef float a
    cdef float pai
    cdef float paj
    cdef float xxx
    cdef float yxx
    for xx in range(res):
        xxx = 1.0 + xx*step
        yxx = 0.0
        for i in range(2*n):
            if i < n:
                pai = par[i]
            else:
                pai = xxx*par[i-n]
            for j in range(2*n):
                if j < n:
                    paj = par[j]
                else:
                    paj = xxx*par[j-n]
                dif = paj - pai
                if dif >= 0:
                    s = dif*0.24/(0.0207*pai + 18.96)
                    a = amp[i%n]*amp[j%n]
                    yxx += 5*a*(expf(-3.51*s) - expf(-5.75*s))
        x[xx] = xxx
        y[xx] = yxx
    return x, y
︡44126e1a-6cc0-4461-a391-a0b41a742408︡{"html":"<a href='/19575ea0-317e-402b-be57-368d04c113db/raw/.sage/temp/compute2dc1/29493/spyx/_projects_19575ea0_317e_402b_be57_368d04c113db__sage_temp_compute2dc1_29493_dir_exah4E_a_pyx/_projects_19575ea0_317e_402b_be57_368d04c113db__sage_temp_compute2dc1_29493_dir_exah4E_a_pyx_0.html' target='_new' class='btn btn-small' style='margin-top: 1ex'>Auto-generated code... &nbsp;<i class='fa fa-external-link'></i></a>"}︡
︠6ffb28da-3e3a-41e6-8bc6-74f80562b758s︠
def plot_diss_curve(x, y, steps_12=False, steps_bp=False):
    DC = list_plot(zip(x,y), plotjoined=True)
    xmax = x[-1]
    ymax = max(y)
    # also plot the steps of 12-tet
    if steps_12:
        N = int(12*log(xmax)/log(2)) + 1
        for i in range(N):
            xx = 2**(i/12)
            DC += line([(xx, 0), (xx,ymax)], color='green')
    # or the steps of bohlen-pierce-et
    if steps_bp:
        N = int(13*log(xmax)/log(3)) + 1
        for i in range(N):
            xx = 3**(i/13)
            DC += line([(xx, 0), (xx,ymax)], color='red')
    return DC

def plot_partials(par, amp):
    n = int(max(par)/min(par) + 1)
    P = list_plot(zip(par, amp))
    for i in range(1, n+1):
        P += line([(i*par[0], 0), (i*par[0],1)], color='gray')
    return P
︡95408ce2-ffb0-4dea-9a1c-5f35a4e77109︡
︠e2b3489e-4698-4be5-abc9-50c0cb6c5cb1s︠
r = factorial(6)
print r
︡19a5020e-1d87-4348-87cc-971b0400d2d3︡{"stdout":"720\n"}︡
︠099f5151-b61d-45ef-9a03-cfaec875569cs︠
# 12 tet, with harmonic partials

# fill in the frequencies of the partials here
par = [440*i for i in [1, 2, 3, 4, 5, 6]]

# with the respective amplitudes
amp  = [0.8**i for i in range(len(par))]

# compute coordinates of curve
x, y = diss_curve(par, amp, ran=2.2, res=r)

# show partials as points, with harmonics as reference
plot_partials(par, amp).show()

# and plot dissonance curve with scale steps
plot_diss_curve(x, y, steps_12=True, steps_bp=False).show()
︡2df30fd5-e66d-4c15-bff5-8a99cdef7eb3︡{"once":false,"file":{"show":true,"uuid":"5ac25108-bf6d-4ee9-9706-0431884a520e","filename":"/projects/19575ea0-317e-402b-be57-368d04c113db/.sage/temp/compute2dc1/29493/tmp_Wf9atx.svg"}}︡{"once":false,"file":{"show":true,"uuid":"6c3921e9-c2ed-4d5c-b210-6578c861c77f","filename":"/projects/19575ea0-317e-402b-be57-368d04c113db/.sage/temp/compute2dc1/29493/tmp_DMyfDG.svg"}}︡
︠abe89883-dc34-4037-8f64-d3b6d6840fe3s︠
# 12-tet, with non-harmonic partials

# fill in the frequencies of the partials here
par = [440*i for i in [1, 2, 2**(19/12), 4, 2**(28/12), 2**(31/12)]]

# with the respective amplitudes
amp  = [0.8**i for i in range(len(par))]

# compute coordinates of curve
x, y = diss_curve(par, amp, ran=2.2, res=r)

# show partials as points, with harmonics as reference
plot_partials(par, amp).show()

# and plot dissonance curve with scale steps
plot_diss_curve(x, y, steps_12=True, steps_bp=False).show()
︡fcb94f2d-5716-4c85-970b-c3d027e4a80f︡{"once":false,"file":{"show":true,"uuid":"d6665bc4-da33-40c3-a7cd-09276b30ef4f","filename":"/projects/19575ea0-317e-402b-be57-368d04c113db/.sage/temp/compute2dc1/29493/tmp_fVTTdx.svg"}}︡{"once":false,"file":{"show":true,"uuid":"be18e702-9227-4790-aaa6-14ee445de620","filename":"/projects/19575ea0-317e-402b-be57-368d04c113db/.sage/temp/compute2dc1/29493/tmp_v7kF1y.svg"}}︡
︠48860ddd-7670-42f5-986d-95b7081a8c59s︠
# Bohlen Pierce et, with odd harmonic partials

# fill in the frequencies of the partials here
par = [440*i for i in [1, 3, 5, 7, 9]]

# with the respective amplitudes
amp  = [0.8**i for i in range(len(par))]

# compute coordinates of curve
x, y = diss_curve(par, amp, ran=3.2, res=r)

# show partials as points, with harmonics as reference
plot_partials(par, amp).show()

# and plot dissonance curve with scale steps
plot_diss_curve(x, y, steps_12=False, steps_bp=True).show()
︡2937e496-91da-40dd-be8f-26e778f782be︡{"once":false,"file":{"show":true,"uuid":"865983ae-12c9-4afc-bd0c-f85fa811c88f","filename":"/projects/19575ea0-317e-402b-be57-368d04c113db/.sage/temp/compute2dc1/29493/tmp_gcwiSw.svg"}}︡{"once":false,"file":{"show":true,"uuid":"ccb9b68a-3918-4221-957a-5eb79e315ae7","filename":"/projects/19575ea0-317e-402b-be57-368d04c113db/.sage/temp/compute2dc1/29493/tmp_7cgEYE.svg"}}︡
︠a7f53fbe-a90d-4e38-8a5e-664be7ad8bdfs︠
# Bohlen Pierce et, with non-harmonic partials

# fill in the frequencies of the partials here
par = [440*i for i in [1, 3, 3**(19/13), 3**(23/13), 9]]

# with the respective amplitudes
amp  = [0.8**i for i in range(len(par))]

# compute coordinates of curve
x, y = diss_curve(par, amp, ran=3.2, res=r)

# show partials as points, with harmonics as reference
plot_partials(par, amp).show()

# and plot dissonance curve with scale steps
plot_diss_curve(x, y, steps_12=False, steps_bp=True).show()
︡ce534495-686b-4dbf-9fc1-8fd8bdda691b︡{"once":false,"file":{"show":true,"uuid":"bd62226f-549d-45db-87cc-c66aa911fa4d","filename":"/projects/19575ea0-317e-402b-be57-368d04c113db/.sage/temp/compute2dc1/29493/tmp_iheSN6.svg"}}︡{"once":false,"file":{"show":true,"uuid":"4c725304-da22-42a1-bb28-611a1803868d","filename":"/projects/19575ea0-317e-402b-be57-368d04c113db/.sage/temp/compute2dc1/29493/tmp_Bd8P3u.svg"}}︡
︠225e7d93-ea79-44a8-95fb-08a5732c5190︠









